mata:
mata clear

real matrix function runningprod(real matrix x,real scalar missing){

	real matrix y
	y = J(rows(x),cols(x),0)
	y[1] = editmissing(x[1],missing)

		for (i=2;i<=rows(x);i++){
			y[i] = y[i-1]*editmissing(x[i],missing)
		}

	return(y)

}


real scalar function genDB1a_2010(i,first_rpi_yr,pi_mid,max_age,sp_get,sp_get_pct){
	
	dbVal = .
	ben = .
	
	st_view(birth_yr=.,i,"X5908")
	st_view(age=.,i,"X14")
	st_view(rec_age=.,i,"X11005")
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
		
	if (st_data(i,"X8021")==1) { //male
		P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
	}
	else { //female
		P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
	}
	
	if (st_data(i,"X6108")!=0) { // has spouse
		st_view(sp_age=.,i,"X19")
		st_view(sp_birth_yr=.,i,"X6108")
		if (st_data(i,"X103")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	else {
		sp_age=age
		Ps = P
	}
	
	if (rec_age<0){ 					// never receive benefit
		dbVal = 0
	}
	else if (st_data(i,"X11014")==2) { 	// lump sum payment
		
		ben = st_data(i,"X11015")
		
		dbVal = ben*Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age]*P[rec_age]/P[age]
	}
		
	else { 								// annuity
	
		if (st_data(i,"X6108")==0) {
			sp_pct = 0
		}
		else {
			sp_pct = sp_get*sp_get_pct
		}
	
		if (st_data(i,"X11014")==3){
			if (st_data(i,"X11016")==2) {
				ben = st_data(i,"X11015")*52
			}
			else if (st_data(i,"X11016")==3) {
				ben = st_data(i,"X11015")*26
			}
			else if (st_data(i,"X11016")==4) {
				ben = st_data(i,"X11015")*12
			}
			else if (st_data(i,"X11016")==5) {
				ben = st_data(i,"X11015")*4
			}
			else {
				ben = st_data(i,"X11015")*1
			}
		}
		else if (st_data(i,"X11014")==1) {
			ben = st_data(i,"X11017")/10000*st_data(i,"salary_ret_h")
		}
		
		dbVal = ben * Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age] / (P[age]*Rmid[birth_yr-first_rpi_yr+rec_age])*
				(P[rec_age::max_age]'*Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age]
				 + (sp_pct/Ps[sp_age])*(Ps[rec_age+(sp_age-age)::max_age]:*(P[rec_age]:-P[rec_age::max_age-(sp_age-age)]))'*
				            Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
		
	}
	
	return(dbVal)
}

real scalar function genDB1b_2010(i,first_rpi_yr,pi_mid,max_age,sp_get,sp_get_pct){
	
	dbVal = .
	ben = .
	
	st_view(birth_yr=.,i,"X5908")
	st_view(age=.,i,"X14")
	st_view(rec_age=.,i,"X11105")
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
		
	if (st_data(i,"X8021")==1) { //male
		P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
	}
	else { //female
		P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
	}
	
	if (st_data(i,"X6108")!=0) { // has spouse
		st_view(sp_age=.,i,"X19")
		st_view(sp_birth_yr=.,i,"X6108")
		if (st_data(i,"X103")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	else {
		sp_age=age
		Ps = P
	}
	
	if (rec_age<0){ 					// never receive benefit
		dbVal = 0
	}
	else if (st_data(i,"X11114")==2) { 	// lump sum payment
		
		ben = st_data(i,"X11115")
		
		dbVal = ben*Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age]*P[rec_age]/P[age]
	}
		
	else { 								// annuity
	
		if (st_data(i,"X6108")==0) {
			sp_pct = 0
		}
		else {
			sp_pct = sp_get*sp_get_pct
		}
	
		if (st_data(i,"X11114")==3){
			if (st_data(i,"X11116")==2) {
				ben = st_data(i,"X11115")*52
			}
			else if (st_data(i,"X11116")==3) {
				ben = st_data(i,"X11115")*26
			}
			else if (st_data(i,"X11116")==4) {
				ben = st_data(i,"X11115")*12
			}
			else if (st_data(i,"X11116")==5) {
				ben = st_data(i,"X11115")*4
			}
			else {
				ben = st_data(i,"X11115")*1
			}
		}
		else if (st_data(i,"X11114")==1) {
			ben = st_data(i,"X11117")/10000*st_data(i,"salary_ret_h")
		}
		
		dbVal = ben * Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age] / (P[age]*Rmid[birth_yr-first_rpi_yr+rec_age])*
				(P[rec_age::max_age]'*Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age]
				 + (sp_pct/Ps[sp_age])*(Ps[rec_age+(sp_age-age)::max_age]:*(P[rec_age]:-P[rec_age::max_age-(sp_age-age)]))'*
				            Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
		
	}
	
	return(dbVal)
}


real scalar function genDB2a_2010(i,first_rpi_yr,pi_mid,max_age,sp_get,sp_get_pct){
	
	dbVal = .
	ben = .
	
	st_view(birth_yr=.,i,"X6108")
	st_view(age=.,i,"X19")
	st_view(rec_age=.,i,"X11305")
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
		
	if (st_data(i,"X103")==1) { //male
		P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
	}
	else { //female
		P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
	}
		
	if (st_data(i,"X6108")!=0) { // has spouse
		st_view(sp_age=.,i,"X19")
		st_view(sp_birth_yr=.,i,"X6108")
		if (st_data(i,"X103")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	else {
		sp_age=age
		Ps = P
	}
	
	if (rec_age<0){ 					// never receive benefit
		dbVal = 0
	}
	else if (st_data(i,"X11314")==2) { 	// lump sum payment
		
		ben = st_data(i,"X11315")
		
		dbVal = ben*Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age]*P[rec_age]/P[age]
	}
		
	else { 								// annuity
	
		if (st_data(i,"X6108")==0) {
			sp_pct = 0
		}
		else {
			sp_pct = sp_get*sp_get_pct
		}
	
		if (st_data(i,"X11314")==3){
			if (st_data(i,"X11316")==2) {
				ben = st_data(i,"X11315")*52
			}
			else if (st_data(i,"X11316")==3) {
				ben = st_data(i,"X11315")*26
			}
			else if (st_data(i,"X11316")==4) {
				ben = st_data(i,"X11315")*12
			}
			else if (st_data(i,"X11316")==5) {
				ben = st_data(i,"X11315")*4
			}
			else {
				ben = st_data(i,"X11315")*1
			}
		}
		else if (st_data(i,"X11314")==1) {
			ben = st_data(i,"X11317")/10000*st_data(i,"salary_ret_h")
		}
		
		dbVal = ben * Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age] / (P[age]*Rmid[birth_yr-first_rpi_yr+rec_age])*
				(P[rec_age::max_age]'*Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age]
				 + (sp_pct/Ps[sp_age])*(Ps[rec_age+(sp_age-age)::max_age]:*(P[rec_age]:-P[rec_age::max_age-(sp_age-age)]))'*
				            Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
		
	}
	
	return(dbVal)
}


real scalar function genDB2b_2010(i,first_rpi_yr,pi_mid,max_age,sp_get,sp_get_pct){
	
	dbVal = .
	ben = .
	
	st_view(birth_yr=.,i,"X6108")
	st_view(age=.,i,"X19")
	st_view(rec_age=.,i,"X11405")
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
		
	if (st_data(i,"X103")==1) { //male
		P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
	}
	else { //female
		P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
	}
		
	if (st_data(i,"X6108")!=0) { // has spouse
		st_view(sp_age=.,i,"X19")
		st_view(sp_birth_yr=.,i,"X6108")
		if (st_data(i,"X103")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	else {
		sp_age=age
		Ps = P
	}
	
	if (rec_age<0){ 					// never receive benefit
		dbVal = 0
	}
	else if (st_data(i,"X11414")==2) { 	// lump sum payment
		
		ben = st_data(i,"X11415")
		
		dbVal = ben*Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age]*P[rec_age]/P[age]
	}
		
	else { 								// annuity
	
		if (st_data(i,"X6108")==0) {
			sp_pct = 0
		}
		else {
			sp_pct = sp_get*sp_get_pct
		}
	
		if (st_data(i,"X11414")==3){
			if (st_data(i,"X11416")==2) {
				ben = st_data(i,"X11415")*52
			}
			else if (st_data(i,"X11416")==3) {
				ben = st_data(i,"X11415")*26
			}
			else if (st_data(i,"X11416")==4) {
				ben = st_data(i,"X11415")*12
			}
			else if (st_data(i,"X11416")==5) {
				ben = st_data(i,"X11415")*4
			}
			else {
				ben = st_data(i,"X11415")*1
			}
		}
		else if (st_data(i,"X11414")==1) {
			ben = st_data(i,"X11417")/10000*st_data(i,"salary_ret_h")
		}
		
		dbVal = ben * Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age] / (P[age]*Rmid[birth_yr-first_rpi_yr+rec_age])*
				(P[rec_age::max_age]'*Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age]
				 + (sp_pct/Ps[sp_age])*(Ps[rec_age+(sp_age-age)::max_age]:*(P[rec_age]:-P[rec_age::max_age-(sp_age-age)]))'*
				            Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
		
	}
	
	return(dbVal)
}

real scalar function genDB1_2010(i,first_rpi_yr,max_age){
	dbVal = .
	ben = .
			
	if (st_data(i,"X5315")==1) {		// pension belongs to head
		st_view(birth_yr=.,i,"X5908")
		st_view(age=.,i,"X14")
		if (st_data(i,"X8021")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		if (st_data(i,"X6108")!=0) { // has spouse
			st_view(sp_age=.,i,"X19")
			st_view(sp_birth_yr=.,i,"X6108")
			if (st_data(i,"X103")==1) { // male
				Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
			}
			else { // female
				Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
			}
		}
		else {
			sp_age=age
			Ps = P
		}
	}
	else {								// pension belongs to spouse
		st_view(birth_yr=.,i,"X6108")
		st_view(age=.,i,"X19")
		if (st_data(i,"X103")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		
		st_view(sp_age=.,i,"X14")
		st_view(sp_birth_yr=.,i,"X5908")
		if (st_data(i,"X8021")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	R    = runningprod(1:/(1:+st_data(.,"r_aaa")),.)
	
	if (st_data(i,"X6108")==0) {
		sp_pct = 0
	}
	else if (st_data(i,"X5322")==-6 | st_data(i,"X5322")==-5 | st_data(i,"X5322")==-4) { 
		sp_pct = 1
	}
	else {
		sp_pct = max((0,st_data(i,"X5322")))/10000
	}
	
	if (st_data(i,"X5319")==2) {
		ben = st_data(i,"X5318")*52
	}
	else if (st_data(i,"X5319")==3) {
		ben = st_data(i,"X5318")*26
	}
	else if (st_data(i,"X5319")==4) {
		ben = st_data(i,"X5318")*12
	}
	else if (st_data(i,"X5319")==5) {
		ben = st_data(i,"X5318")*4
	}
	else {
		ben = st_data(i,"X5318")*1
	}
	
	if (st_data(i,"X5320")==1) { 	// pension is cost of living adjusted
		dbVal = ben/(R[birth_yr-first_rpi_yr+age]*P[age])*
				(P[age::max_age]'*R[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]
				  + (sp_pct/Ps[sp_age])*(Ps[sp_age::max_age]:*(P[age]:-P[age::max_age-(sp_age-age)]))'*
				            R[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
	else {							// pension is not cost of living adjusted
		dbVal = ben/(Rpi[birth_yr-first_rpi_yr+age]*P[age])*
				(P[age::max_age]'*Rpi[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]
				  + (sp_pct/Ps[sp_age])*(Ps[sp_age::max_age]:*(P[age]:-P[age::max_age-(sp_age-age)]))'*
				            Rpi[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
		
	return(dbVal)
}

real scalar function genDB2_2010(i,first_rpi_yr,max_age){
	
	dbVal = .
	ben = .
			
	if (st_data(i,"X5323")==1) {		// pension belongs to head
		st_view(birth_yr=.,i,"X5908")
		st_view(age=.,i,"X14")
		if (st_data(i,"X8021")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		if (st_data(i,"X6108")!=0) { // has spouse
			st_view(sp_age=.,i,"X19")
			st_view(sp_birth_yr=.,i,"X6108")
			if (st_data(i,"X103")==1) { // male
				Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
			}
			else { // female
				Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
			}
		}
		else {
			sp_age=age
			Ps = P
		}
	}
	else {								// pension belongs to spouse
		st_view(birth_yr=.,i,"X6108")
		st_view(age=.,i,"X19")
		if (st_data(i,"X103")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		
		st_view(sp_age=.,i,"X14")
		st_view(sp_birth_yr=.,i,"X5908")
		if (st_data(i,"X8021")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	R    = runningprod(1:/(1:+st_data(.,"r_aaa")),.)
	
	if (st_data(i,"X6108")==0) {
		sp_pct = 0
	}
	else if (st_data(i,"X5330")==-6 | st_data(i,"X5330")==-5 | st_data(i,"X5330")==-4) { 
		sp_pct = 1
	}
	else {
		sp_pct = max((0,st_data(i,"X5330")))/10000
	}
	
	if (st_data(i,"X5327")==2) {
		ben = st_data(i,"X5326")*52
	}
	else if (st_data(i,"X5327")==3) {
		ben = st_data(i,"X5326")*26
	}
	else if (st_data(i,"X5327")==4) {
		ben = st_data(i,"X5326")*12
	}
	else if (st_data(i,"X5327")==5) {
		ben = st_data(i,"X5326")*4
	}
	else {
		ben = st_data(i,"X5326")*1
	}
	
	if (st_data(i,"X5328")==1) { 	// pension is cost of living adjusted
		dbVal = ben/(R[birth_yr-first_rpi_yr+age]*P[age])*
				(P[age::max_age]'*R[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]
				  + (sp_pct/Ps[sp_age])*(Ps[sp_age::max_age]:*(P[age]:-P[age::max_age-(sp_age-age)]))'*
				            R[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
	else {							// pension is not cost of living adjusted
		dbVal = ben/(Rpi[birth_yr-first_rpi_yr+age]*P[age])*
				(P[age::max_age]'*Rpi[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]
				  + (sp_pct/Ps[sp_age])*(Ps[sp_age::max_age]:*(P[age]:-P[age::max_age-(sp_age-age)]))'*
				            Rpi[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
		
	return(dbVal)
}
real scalar function genDB3_2010(i,first_rpi_yr,max_age){
	
	dbVal = .
	ben = .
			
	if (st_data(i,"X5331")==1) {		// pension belongs to head
		st_view(birth_yr=.,i,"X5908")
		st_view(age=.,i,"X14")
		if (st_data(i,"X8021")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		if (st_data(i,"X6108")!=0) { // has spouse
			st_view(sp_age=.,i,"X19")
			st_view(sp_birth_yr=.,i,"X6108")
			if (st_data(i,"X103")==1) { // male
				Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
			}
			else { // female
				Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
			}
		}
		else {
			sp_age=age
			Ps = P
		}
	}
	else {								// pension belongs to spouse
		st_view(birth_yr=.,i,"X6108")
		st_view(age=.,i,"X19")
		if (st_data(i,"X103")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		
		st_view(sp_age=.,i,"X14")
		st_view(sp_birth_yr=.,i,"X5908")
		if (st_data(i,"X8021")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	R    = runningprod(1:/(1:+st_data(.,"r_aaa")),.)
		
	if (st_data(i,"X6108")==0) {
		sp_pct = 0
	}
	else if (st_data(i,"X5338")==-6 | st_data(i,"X5338")==-5 | st_data(i,"X5338")==-4) { 
		sp_pct = 1
	}
	else {
		sp_pct = max((0,st_data(i,"X5338")))/10000
	}
	
	if (st_data(i,"X5335")==2) {
		ben = st_data(i,"X5334")*52
	}
	else if (st_data(i,"X5335")==3) {
		ben = st_data(i,"X5334")*26
	}
	else if (st_data(i,"X5335")==4) {
		ben = st_data(i,"X5334")*12
	}
	else if (st_data(i,"X5335")==5) {
		ben = st_data(i,"X5334")*4
	}
	else {
		ben = st_data(i,"X5334")*1
	}
	
	if (st_data(i,"X5336")==1) { 	// pension is cost of living adjusted
		dbVal = ben/(R[birth_yr-first_rpi_yr+age]*P[age])*
				(P[age::max_age]'*R[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]
				  + (sp_pct/Ps[sp_age])*(Ps[sp_age::max_age]:*(P[age]:-P[age::max_age-(sp_age-age)]))'*
				            R[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
	else {							// pension is not cost of living adjusted
		dbVal = ben/(Rpi[birth_yr-first_rpi_yr+age]*P[age])*
				(P[age::max_age]'*Rpi[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]
				  + (sp_pct/Ps[sp_age])*(Ps[sp_age::max_age]:*(P[age]:-P[age::max_age-(sp_age-age)]))'*
				            Rpi[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
		
	return(dbVal)
}
real scalar function genDB4_2010(i,first_rpi_yr,max_age){
	
	dbVal = .
	ben = .
			
	if (st_data(i,"X5415")==1) {		// pension belongs to head
		st_view(birth_yr=.,i,"X5908")
		st_view(age=.,i,"X14")
		if (st_data(i,"X8021")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		if (st_data(i,"X6108")!=0) { // has spouse
			st_view(sp_age=.,i,"X19")
			st_view(sp_birth_yr=.,i,"X6108")
			if (st_data(i,"X103")==1) { // male
				Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
			}
			else { // female
				Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
			}
		}
		else {
			sp_age=age
			Ps = P
		}
	}
	else {								// pension belongs to spouse
		st_view(birth_yr=.,i,"X6108")
		st_view(age=.,i,"X19")
		if (st_data(i,"X103")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		
		st_view(sp_age=.,i,"X14")
		st_view(sp_birth_yr=.,i,"X5908")
		if (st_data(i,"X8021")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	R    = runningprod(1:/(1:+st_data(.,"r_aaa")),.)
			
	if (st_data(i,"X6108")==0) {
		sp_pct = 0
	}
	else if (st_data(i,"X5422")==-6 | st_data(i,"X5422")==-5 | st_data(i,"X5422")==-4) { 
		sp_pct = 1
	}
	else {
		sp_pct = max((0,st_data(i,"X5422")))/10000
	}
	
	if (st_data(i,"X5419")==2) {
		ben = st_data(i,"X5418")*52
	}
	else if (st_data(i,"X5419")==3) {
		ben = st_data(i,"X5418")*26
	}
	else if (st_data(i,"X5419")==4) {
		ben = st_data(i,"X5418")*12
	}
	else if (st_data(i,"X5419")==5) {
		ben = st_data(i,"X5418")*4
	}
	else {
		ben = st_data(i,"X5418")*1
	}
	
	if (st_data(i,"X5420")==1) { 	// pension is cost of living adjusted
		dbVal = ben/(R[birth_yr-first_rpi_yr+age]*P[age])*
				(P[age::max_age]'*R[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]
				  + (sp_pct/Ps[sp_age])*(Ps[sp_age::max_age]:*(P[age]:-P[age::max_age-(sp_age-age)]))'*
				            R[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
	else {							// pension is not cost of living adjusted
		dbVal = ben/(Rpi[birth_yr-first_rpi_yr+age]*P[age])*
				(P[age::max_age]'*Rpi[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]
				  + (sp_pct/Ps[sp_age])*(Ps[sp_age::max_age]:*(P[age]:-P[age::max_age-(sp_age-age)]))'*
				            Rpi[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
		
	return(dbVal)
}
real scalar function genDB5_2010(i,first_rpi_yr,pi_mid,max_age){
	
	dbVal = .
			
	st_view(birth_yr=.,i,"X5908")
	st_view(age=.,i,"X14")
	if (st_data(i,"X8021")==1) { // male
		P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
	}
	else { // female
		P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
	}

	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
	
	ben = max((0,st_data(i,"X6958")*12))
	dbVal = ben/(Rmid[birth_yr-first_rpi_yr+age]*P[age])*P[age::max_age]'*Rmid[birth_yr-first_rpi_yr+age::birth_yr-first_rpi_yr+max_age]

		
	return(dbVal)
}
real scalar function genDBA_2010(i,first_rpi_yr,pi_mid,max_age,sp_get,sp_get_pct){
	
	dbVal = .
	ben = .
	
	if (st_data(i,"X5606")==1) {		// pension belongs to head
		st_view(birth_yr=.,i,"X5908")
		st_view(age=.,i,"X14")
		if (st_data(i,"X8021")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		if (st_data(i,"X6108")!=0) { // has spouse
			st_view(sp_age=.,i,"X19")
			st_view(sp_birth_yr=.,i,"X6108")
			if (st_data(i,"X103")==1) { // male
				Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
			}
			else { // female
				Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
			}
		}
		else {
			sp_age=age
			Ps = P
		}
	}
	else {								// pension belongs to spouse
		st_view(birth_yr=.,i,"X6108")
		st_view(age=.,i,"X19")
		if (st_data(i,"X103")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		
		st_view(sp_age=.,i,"X14")
		st_view(sp_birth_yr=.,i,"X5908")
		if (st_data(i,"X8021")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	
	st_view(rec_age=.,i,"X5607")
	
	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
	
	if (rec_age<0){ 					// never receive benefit
		dbVal = 0
	}
	else if (st_data(i,"X5609")==8) { 	// lump sum payment
		
		ben = st_data(i,"X5608")
		
		dbVal = ben*Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age]*P[rec_age]/P[age]
	}
		
	else { 								// annuity
	
		if (st_data(i,"X6108")==0) {
			sp_pct = 0
		}
		else {
			sp_pct = sp_get*sp_get_pct
		}
	
		if (st_data(i,"X5609")==2) {
			ben = st_data(i,"X5608")*52
		}
		else if (st_data(i,"X5609")==3) {
			ben = st_data(i,"X5608")*26
		}
		else if (st_data(i,"X5609")==4) {
			ben = st_data(i,"X5608")*12
		}
		else if (st_data(i,"X5609")==5) {
			ben = st_data(i,"X5608")*4
		}
		else {
			ben = st_data(i,"X5608")*1
		}
			
		dbVal = ben * Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age] / (P[age]*Rmid[birth_yr-first_rpi_yr+rec_age])*
				(P[rec_age::max_age]'*Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age]
				 + (sp_pct/Ps[sp_age])*(Ps[rec_age+(sp_age-age)::max_age]:*(P[rec_age]:-P[rec_age::max_age-(sp_age-age)]))'*
				            Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
	
	return(dbVal)
}

real scalar function genDBB_2010(i,first_rpi_yr,pi_mid,max_age,sp_get,sp_get_pct){
	
	dbVal = .
	ben = .
	
	if (st_data(i,"X5614")==1) {		// pension belongs to head
		st_view(birth_yr=.,i,"X5908")
		st_view(age=.,i,"X14")
		if (st_data(i,"X8021")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		if (st_data(i,"X6108")!=0) { // has spouse
			st_view(sp_age=.,i,"X19")
			st_view(sp_birth_yr=.,i,"X6108")
			if (st_data(i,"X103")==1) { // male
				Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
			}
			else { // female
				Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
			}
		}
		else {
			sp_age=age
			Ps = P
		}
	}
	else {								// pension belongs to spouse
		st_view(birth_yr=.,i,"X6108")
		st_view(age=.,i,"X19")
		if (st_data(i,"X103")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		
		st_view(sp_age=.,i,"X14")
		st_view(sp_birth_yr=.,i,"X5908")
		if (st_data(i,"X8021")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	
	st_view(rec_age=.,i,"X5615")

	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
	
	if (rec_age<0){ 					// never receive benefit
		dbVal = 0
	}
	else if (st_data(i,"X5617")==8) { 	// lump sum payment
		
		ben = st_data(i,"X5616")
		
		dbVal = ben*Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age]*P[rec_age]/P[age]
	}
		
	else { 								// annuity
	
		if (st_data(i,"X6108")==0) {
			sp_pct = 0
		}
		else {
			sp_pct = sp_get*sp_get_pct
		}
	
		if (st_data(i,"X5617")==2) {
			ben = st_data(i,"X5616")*52
		}
		else if (st_data(i,"X5617")==3) {
			ben = st_data(i,"X5616")*26
		}
		else if (st_data(i,"X5617")==4) {
			ben = st_data(i,"X5616")*12
		}
		else if (st_data(i,"X5617")==5) {
			ben = st_data(i,"X5616")*4
		}
		else {
			ben = st_data(i,"X5616")*1
		}
			
		dbVal = ben * Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age] / (P[age]*Rmid[birth_yr-first_rpi_yr+rec_age])*
				(P[rec_age::max_age]'*Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age]
				 + (sp_pct/Ps[sp_age])*(Ps[rec_age+(sp_age-age)::max_age]:*(P[rec_age]:-P[rec_age::max_age-(sp_age-age)]))'*
				            Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
	
	return(dbVal)
}

real scalar function genDBC_2010(i,first_rpi_yr,pi_mid,max_age,sp_get,sp_get_pct){
	
	dbVal = .
	ben = .
	
	if (st_data(i,"X5622")==1) {		// pension belongs to head
		st_view(birth_yr=.,i,"X5908")
		st_view(age=.,i,"X14")
		if (st_data(i,"X8021")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		if (st_data(i,"X6108")!=0) { // has spouse
			st_view(sp_age=.,i,"X19")
			st_view(sp_birth_yr=.,i,"X6108")
			if (st_data(i,"X103")==1) { // male
				Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
			}
			else { // female
				Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
			}
		}
		else {
			sp_age=age
			Ps = P
		}
	}
	else {								// pension belongs to spouse
		st_view(birth_yr=.,i,"X6108")
		st_view(age=.,i,"X19")
		if (st_data(i,"X103")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		
		st_view(sp_age=.,i,"X14")
		st_view(sp_birth_yr=.,i,"X5908")
		if (st_data(i,"X8021")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	
	st_view(rec_age=.,i,"X5623")

	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
	
	if (rec_age<0){ 					// never receive benefit
		dbVal = 0
	}
	else if (st_data(i,"X5625")==8) { 	// lump sum payment
		
		ben = st_data(i,"X5624")
		
		dbVal = ben*Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age]*P[rec_age]/P[age]
	}
		
	else { 								// annuity
	
		if (st_data(i,"X6108")==0) {
			sp_pct = 0
		}
		else {
			sp_pct = sp_get*sp_get_pct
		}
	
		if (st_data(i,"X5625")==2) {
			ben = st_data(i,"X5624")*52
		}
		else if (st_data(i,"X5625")==3) {
			ben = st_data(i,"X5624")*26
		}
		else if (st_data(i,"X5625")==4) {
			ben = st_data(i,"X5624")*12
		}
		else if (st_data(i,"X5625")==5) {
			ben = st_data(i,"X5624")*4
		}
		else {
			ben = st_data(i,"X5624")*1
		}
			
		dbVal = ben * Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age] / (P[age]*Rmid[birth_yr-first_rpi_yr+rec_age])*
				(P[rec_age::max_age]'*Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age]
				 + (sp_pct/Ps[sp_age])*(Ps[rec_age+(sp_age-age)::max_age]:*(P[rec_age]:-P[rec_age::max_age-(sp_age-age)]))'*
				            Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
	
	return(dbVal)
}

real scalar function genDBD_2010(i,first_rpi_yr,pi_mid,max_age,sp_get,sp_get_pct){
	
	dbVal = .
	ben = .
	
	if (st_data(i,"X5630")==1) {		// pension belongs to head
		st_view(birth_yr=.,i,"X5908")
		st_view(age=.,i,"X14")
		if (st_data(i,"X8021")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		if (st_data(i,"X6108")!=0) { // has spouse
			st_view(sp_age=.,i,"X19")
			st_view(sp_birth_yr=.,i,"X6108")
			if (st_data(i,"X103")==1) { // male
				Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
			}
			else { // female
				Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
			}
		}
		else {
			sp_age=age
			Ps = P
		}
	}
	else {								// pension belongs to spouse
		st_view(birth_yr=.,i,"X6108")
		st_view(age=.,i,"X19")
		if (st_data(i,"X103")==1) { // male
			P = runningprod(1:-st_data(.,"m"+strofreal(birth_yr)),1)
		}
		else { // female
			P = runningprod(1:-st_data(.,"f"+strofreal(birth_yr)),1)
		}
		
		st_view(sp_age=.,i,"X14")
		st_view(sp_birth_yr=.,i,"X5908")
		if (st_data(i,"X8021")==1) { // male
			Ps = runningprod(1:-st_data(.,"m"+strofreal(sp_birth_yr)),1)
		}
		else { // female
			Ps = runningprod(1:-st_data(.,"f"+strofreal(sp_birth_yr)),1)
		}
	}
	
	st_view(rec_age=.,i,"X5631")

	Rpi  = runningprod(1:/(1:+st_data(.,"r_aaa"):+st_data(.,"pi_liv")),.)
	Rmid = runningprod(1:/(1:+st_data(.,"r_aaa"):+pi_mid:*st_data(.,"pi_liv")),.)
	
	if (rec_age<0){ 					// never receive benefit
		dbVal = 0
	}
	else if (st_data(i,"X5633")==8) { 	// lump sum payment
		
		ben = st_data(i,"X5632")
		
		dbVal = ben*Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age]*P[rec_age]/P[age]
	}
		
	else { 								// annuity
	
		if (st_data(i,"X6108")==0) {
			sp_pct = 0
		}
		else {
			sp_pct = sp_get*sp_get_pct
		}
	
		if (st_data(i,"X5633")==2) {
			ben = st_data(i,"X5632")*52
		}
		else if (st_data(i,"X5633")==3) {
			ben = st_data(i,"X5632")*26
		}
		else if (st_data(i,"X5633")==4) {
			ben = st_data(i,"X5632")*12
		}
		else if (st_data(i,"X5633")==5) {
			ben = st_data(i,"X5632")*4
		}
		else {
			ben = st_data(i,"X5632")*1
		}
			
		dbVal = ben * Rpi[birth_yr-first_rpi_yr+rec_age]/Rpi[birth_yr-first_rpi_yr+age] / (P[age]*Rmid[birth_yr-first_rpi_yr+rec_age])*
				(P[rec_age::max_age]'*Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age]
				 + (sp_pct/Ps[sp_age])*(Ps[rec_age+(sp_age-age)::max_age]:*(P[rec_age]:-P[rec_age::max_age-(sp_age-age)]))'*
				            Rmid[birth_yr-first_rpi_yr+rec_age::birth_yr-first_rpi_yr+max_age-(sp_age-age)])
	}
	
	return(dbVal)
}


mata mlib create ldbval2010, dir("\\bbking2\perryb\winprofile\desktop\SCF\2010\") replace
mata mlib add ldbval2010 *(), dir("\\bbking2\perryb\winprofile\desktop\SCF\2010\")
mata mlib index
end
